//
// Real Time Linux Example of a oscilloscope Widget
//

#ifndef SCOPE_H
#define SCOPE_H

#include <stdio.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include <qtimer.h>
#include <qframe.h>
#include <qcombo.h>
#include <qevent.h>
#include <qpushbt.h>

#define MAX 1500

class Channel : public QWidget
{
	Q_OBJECT
public slots:
    void SetVoltageScale(int);
    void SetInputRange(int);
    void SetTimeScale(int);
    void Pause();

protected:
    int         in_file;  		// fifo for real time data 
    int		myTimer;
    void 	timerEvent( QTimerEvent *);
    void 	paintEvent( QPaintEvent * ); 

public:
	Channel( QWidget *parent=0, int fifo = 0, const char *name=0);
	int data[MAX];
        int index;
	int voltage_scale;
	int input_range;
	int time_scale;
	int pause;

	void SetData(int*, int);
	void ResetData() {};
	void GetNewData();

	void ShowSignal(QPainter *);
        void ClearDisplay(QPainter *);
};

class Scope : public QWidget		
{
    Q_OBJECT
public:
    Scope( QWidget *parent=0, const char *name=0 );

protected:			// event handlers

private slots:			// internal slots

private:					// internal data
    QLineEdit    *temp_base;
    QPushButton  *quit;
    Channel	 *channels;
};

#endif // SCOPE_H
